"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = dsqlCrud;
const post_1 = __importDefault(require("../../actions/post"));
const sql_generator_1 = __importDefault(require("../../functions/dsql/sql/sql-generator"));
const conn_db_handler_1 = __importDefault(require("../db/conn-db-handler"));
function dsqlCrud(_a) {
    return __awaiter(this, arguments, void 0, function* ({ action, data, table, targetId, query, sanitize, debug, }) {
        const finalData = sanitize ? sanitize(data) : data;
        const finalId = targetId;
        let queryObject;
        switch (action) {
            case "get":
                queryObject = (0, sql_generator_1.default)({
                    tableName: table,
                    genObject: query,
                });
                const GET_RES = yield (0, conn_db_handler_1.default)(global.DSQL_DB_CONN, (queryObject === null || queryObject === void 0 ? void 0 : queryObject.string) || "", (queryObject === null || queryObject === void 0 ? void 0 : queryObject.values) || []);
                return Object.assign(Object.assign({}, GET_RES), { queryObject });
            case "insert":
                return yield (0, post_1.default)({
                    query: {
                        action: "insert",
                        table,
                        data: finalData,
                    },
                });
            case "update":
                data === null || data === void 0 ? true : delete data.id;
                return yield (0, post_1.default)({
                    query: {
                        action: "update",
                        table,
                        identifierColumnName: "id",
                        identifierValue: String(finalId),
                        data: finalData,
                    },
                });
            case "delete":
                return yield (0, post_1.default)({
                    query: {
                        action: "delete",
                        table,
                        identifierColumnName: "id",
                        identifierValue: String(finalId),
                    },
                });
            default:
                return null;
        }
    });
}
